#!/usr/bin/perl
  
use strict;
use Getopt::Long;

my $usage = "

    usage: $0 <diag sniffer input>

    or use - to read from stdin

    create a pcap file directly:

    ssh -l admin fgt.domain.name \"diag sniffer packet any '' 3 0 l\" | $0 - | text2pcap - <outputfile>

";

print $#ARGV;

my $fh;
my $in;

if ($#ARGV >= 0) { $in = $ARGV[0]; }

if ( -e $in ) {
	open  ($fh, '<', $in) or die "cannot read $in: $!\n $usage";
} elsif ( $in =~ /^-$/ ) {
	$fh = *STDIN;
} else {
	die "$in does not exist or is not readable\n $usage";
}  


while (<$fh>) {
	# 2018-07-30 07:00:22.154432
	if ( /^\d+-\d+-\d+\s+\d+:\d+:\d+\.\d+/ ) {
		my ($date, $time) = /^(\d+-\d+-\d+)\s+(\d+:\d+:\d+\.\d+)\s+/;
		print $date . ' ' . $time . "\n";
	} elsif ( /^$/ ) {
		print;
	} elsif ( /^0x/ ) {
		s/0x/00/;
		#s/^(.{48}).*/$1/; 
		s/^(\w+)\s+(.*)\t(.*)/$1 $2/; 
		my ($offset, $b1, $b2, $b3, $b4, $b5, $b6, $b7, $b8, $dummy) = split ' ';
		print $offset . '  ';
		foreach my $block ( $b1, $b2, $b3, $b4, $b5, $b6, $b7, $b8 ) {
			if ( $block ) { 
				substr $block, 2, 0, ' ';		
				print $block . ' ';
			}
		}
		print "\n";
	}
}

